<template>
  <rui-form :errors="errors"
            model="genus"
            :loading="loading"
            @cancel="$emit('cancel')"
            @submit.prevent="save">
    <rui-alert variant="info">{{ $t('js.genera.form.community_alert') }}</rui-alert>

    <rui-field input-id="genus_name" :label="$t('activerecord.attributes.genus.name')">
      <input id="genus_name"
             v-model="inputs.name"
             type="text"
             name="name"
             autocomplete="off"
             required>
      <template #help>
        <div v-if="searchResults.length > 0">
          {{ $t('js.genera.form.already_created') }}
          <rui-badge v-for="result in searchResults"
                     :key="result.id"
                     :caption="result.name"
                     variant="help"
                     size="small" />
        </div>
      </template>
    </rui-field>

    <rui-field input-id="genus_family" :label="$t('activerecord.attributes.genus.family')">
      <multiselect id="genus_family"
                   v-model="family"
                   :options="families"
                   :allow-empty="false"
                   track-by="id"
                   label="name" />
    </rui-field>

    <rui-field input-id="genus_source" :label="$t('activerecord.attributes.genus.source')" :help="$t('js.genera.form.source_help')">
      <input id="genus_source" v-model="inputs.source" type="url" name="source">
    </rui-field>
  </rui-form>
</template>
<script>
import RuiAlert from '@experiments-labs/rise_ui/src/components/Alert/Alert.vue'
import RuiBadge from '@experiments-labs/rise_ui/src/components/Badge/Badge.vue'
import RuiField from '@experiments-labs/rise_ui/src/components/Form/Field.vue'
import RuiForm from '@experiments-labs/rise_ui/src/components/Form/Form.vue'

import Multiselect from 'vue-multiselect'
import Genus from '../../../../classes/models/Genus'
import Toaster from '../../../../tools/Toaster'

export default {
  name: 'GpaGeneraForm',
  emits: [
    'cancel',
    'saved',
  ],
  components: { RuiBadge, RuiField, RuiAlert, RuiForm, Multiselect },
  props: {
    genus: { required: false, type: Genus, default: null },
  },
  data () {
    return {
      inputs: { ...this.fillInputs() },
      family: this.initializeFamily(),
      errors: null,
      loading: false,
    }
  },
  computed: {
    families () { return this.$store.getters.families },
    searchResults () { return this.$store.getters.genusSearch(this.inputs.name) },
  },
  methods: {
    fillInputs () {
      return {
        id: null,
        name: '',
        description: '',
        source: '',
        familyId: null,
        ...this.$props.genus,
      }
    },
    initializeFamily () {
      if (this.$props.genus && this.$props.genus.familyId) {
        const family = this.$props.genus.family
        return { id: family.id, name: family.name }
      }
      return null
    },
    save () {
      const payload = {
        id: this.inputs.id,
        name: this.inputs.name,
        description: this.inputs.description,
        source: this.inputs.source,
        family_id: this.family.id,
      }
      if (!payload.id) { delete payload.id }

      this.loading = true
      this.errors = null
      this.$store.dispatch('saveGenus', payload)
        .then(() => {
          Toaster.success(this.$t('js.generic.successfully_saved'))
          this.$emit('saved')
        })
        .catch((errors) => {
          Toaster.error(this.$t('js.generic.failed_to_save'))
          this.errors = errors
        })
        .then(() => { this.loading = false })
    },
  },
  watch: {
    genus () {
      this.inputs = this.fillInputs()
      // Reset values for vue-multiselect
      this.family = this.initializeFamily()
    },
  },
}
</script>
